=== modified file 'Makefile'
--- Makefile	2008-07-22 01:59:47 +0000
+++ Makefile	2008-07-20 02:52:20 +0000
@@ -1,28 +1,13 @@
-WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs -Wswitch-default -Wswitch-enum -Wunused-parameter -Wstrict-aliasing=2 -Wextra -Wfloat-equal -Wundef -Wshadow -Wunsafe-loop-optimizations -Wpointer-arith -Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wstrict-prototypes -Wold-style-definition -Wpacked -Wnested-externs -Wunreachable-code -Winline -Wvolatile-register-var 
-DEBUG=-ggdb3
-#COVERAGE=--coverage
-OPTIMIZE=-Os
-LANGUAGE=-std=gnu99
-
-# Do not change these two
-CFLAGS=$(WARN) $(COVERAGE) $(DEBUG) $(OPTIMIZE) $(LANGUAGE)
-LDFLAGS=$(COVERAGE)
-
-PROGS=plugbasedclient plugins.d/mandosclient plugins.d/passprompt
-
-objects=$(shell for p in $(PROGS); do echo $${p}.o; done)
-
-all: $(PROGS)
-
-plugbasedclient: plugbasedclient.o
-	$(LINK.o) -lgnutls $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/mandosclient: plugins.d/mandosclient.o
-	$(LINK.o) -lgnutls -lavahi-core -lgpgme $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/passprompt: plugins.d/passprompt.o
-	$(LINK.o) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-.PHONY : clean
+CFLAGS="-Wall -std=gnu99"
+LDFLAGS=-lgnutls
+
+all: plugbasedclient
+
 clean:
-	-rm -f $(PROGS) $(objects) core
+	rm -f plugbasedclient
+
+client_debug: client
+	mv -f client client.tmp
+	$(MAKE) client CXXFLAGS="$(CXXFLAGS) -DDEBUG -DCERT_ROOT=\\\"./\\\""
+	mv client client_debug
+	mv client.tmp client

=== modified file 'TODO'
--- TODO	2008-07-22 06:23:29 +0000
+++ TODO	2008-07-19 18:43:24 +0000
@@ -1,25 +1,16 @@
-[Mandos client]
-configuration for OpenPGP key
-header files/symbols tally
-check exit codes of all system calls
+[Client]
+configuration for cert, key, CA and interface
 IPv4 support
-
-[Pluginbasedclient]
-disable certain plugins
-header files/symbols tally
-check exit codes of all system calls
-change uid to nobody:nogroup
-	other drop privs stuff?
+OpenPGP keys support
 
 [Server]
-config file for:
-	TXT record
+config file
+client-list
 run-time communication with server
 
+handle SIGTERM, SIGQUIT, etc.
+
 [Mandos-tools/utilities]
 	List clients
 	Enable client
 	Disable client
-
-[Installer]
-...

=== modified file 'mandos-clients.conf'
--- mandos-clients.conf	2008-07-22 06:23:29 +0000
+++ mandos-clients.conf	2008-07-20 02:52:20 +0000
@@ -1,17 +1,10 @@
-[DEFAULT]
-timeout = 1h
-interval = 5m
-checker = fping -q -- %%(fqdn)s
-
 # Example
-[foo]
-fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
-secret = Base+64+encoded+OpenPGP+encrypted+data/=
-# secfile = /etc/mandos/foo-secret.txt.asc
-fqdn = foo.example.org
-checker = fping -q -- %%(fqdn)s
-timeout = 10m
-
+#[foo]
+#fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
+#secfile = openpgp/secret.txt.asc
+#fqdn = foo.example.org
+#checker = echo %%(fqdn)s >&2; false
+#
 [braxen_client]
 fingerprint =  7788 2722 5BA7 DE53 9C5A  7CFA 59CF F7CD BD9A 5920
 secret =

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-08-02 14:48:45 +0000
+++ plugbasedclient.c	2008-07-20 02:52:20 +0000
@@ -1,29 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Mandos plugin runner - Run Mandos plugins
- *
- * Copyright © 2007-2008 Teddy Hogeborn and Björn Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _FORTIFY_SOURCE 2
-
 #include <stdio.h>	/* popen, fileno */
 #include <iso646.h>	/* and, or, not */
 #include <sys/types.h>	/* DIR, opendir, stat, struct stat, waitpid,
@@ -33,13 +7,11 @@
 #include <sys/stat.h>	/* stat, struct stat */
 #include <unistd.h>	/* stat, struct stat, chdir */
 #include <stdlib.h>	/* EXIT_FAILURE */
-#include <sys/select.h>	/* fd_set, select, FD_ZERO, FD_SET,
-			   FD_ISSET */
+#include <sys/select.h>	/* fd_set, select, FD_ZERO, FD_SET, FD_ISSET */
 #include <string.h>	/* strlen, strcpy, strcat */
 #include <stdbool.h>	/* true */
 #include <sys/wait.h>	/* waitpid, WIFEXITED, WEXITSTATUS */
 #include <errno.h>	/* errno */
-#include <argp.h>	/* argp */
 
 struct process;
 
@@ -47,186 +19,25 @@
   pid_t pid;
   int fd;
   char *buffer;
-  size_t buffer_size;
-  size_t buffer_length;
+  int buffer_size;
+  int buffer_length;
   struct process *next;
 } process;
 
-typedef struct plugin{
-  char *name; 		/* can be "global" and any plugin name */
-  char **argv;
-  int argc;
-  bool disable;
-  struct plugin *next;
-} plugin;
-
-plugin *getplugin(char *name, plugin **plugin_list){
-  for (plugin *p = *plugin_list; p != NULL; p = p->next){
-    if ((p->name == name)
-	or (p->name and name and (strcmp(p->name, name) == 0))){
-      return p;
-    }
-  }
-  /* Create a new plugin */
-  plugin *new_plugin = malloc(sizeof(plugin));
-  if (new_plugin == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->name = name;
-  new_plugin->argv = malloc(sizeof(char *) * 2);
-  if (new_plugin->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  new_plugin->argv[0] = name;
-  new_plugin->argv[1] = NULL;
-  new_plugin->argc = 1;
-  new_plugin->disable = false;
-  new_plugin->next = *plugin_list;
-  /* Append the new plugin to the list */
-  *plugin_list = new_plugin;
-  return new_plugin;
-}
-
-void addarguments(plugin *p, char *arg){
-  p->argv[p->argc] = arg;
-  p->argv = realloc(p->argv, sizeof(char *) * (size_t)(p->argc + 2));
-  if (p->argv == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  p->argc++;
-  p->argv[p->argc] = NULL;
-}
-	
 #define BUFFER_SIZE 256
 
-const char *argp_program_version =
-  "plugbasedclient 0.9";
-const char *argp_program_bug_address =
-  "<mandos@fukt.bsnet.se>";
-static char doc[] =
-  "Mandos plugin runner -- Run Mandos plugins";
-/* A description of the arguments we accept. */
-static char args_doc[] = "";
-
 int main(int argc, char *argv[]){
-  const char *plugindir = "plugins.d";
-  size_t d_name_len;
+  char plugindir[] = "plugins.d";
+  size_t d_name_len, plugindir_len = sizeof(plugindir)-1;
   DIR *dir;
   struct dirent *dirst;
   struct stat st;
   fd_set rfds_orig;
   int ret, maxfd = 0;
   process *process_list = NULL;
-  uid_t uid = 65534;
-  gid_t gid = 65534;
-  /* The options we understand. */
-  struct argp_option options[] = {
-    { .name = "global-options", .key = 'g',
-      .arg = "option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting all plugins" },
-    { .name = "options-for", .key = 'o',
-      .arg = "plugin:option[,option[,...]]", .flags = 0,
-      .doc = "Options effecting only specified plugins" },
-    { .name = "disable-plugin", .key = 'd',
-      .arg = "Plugin[,Plugin[,...]]", .flags = 0,
-      .doc = "Option to disable specififed plugins" },
-    { .name = "plugin-dir", .key = 128,
-      .arg = "Directory", .flags = 0,
-      .doc = "Option to change directory to search for plugins" },
-    { .name = "userid", .key = 129,
-      .arg = "Id", .flags = 0,
-      .doc = "Option to change which user id the plugins will run as" },
-    { .name = "groupid", .key = 130,
-      .arg = "Id", .flags = 0,
-      .doc = "Option to change which group id the plugins will run as" },
-    { .name = NULL }
-  };
-  
-  error_t parse_opt (int key, char *arg, struct argp_state *state) {
-       /* Get the INPUT argument from `argp_parse', which we
-          know is a pointer to our arguments structure. */
-    plugin **plugins = state->input;
-    switch (key) {
-    case 'g':
-      if (arg != NULL){
-	char *p = strtok(arg, ",");
-	do{
-	  addarguments(getplugin(NULL, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case 'o':
-      if (arg != NULL){
-	char *name = strtok(arg, ":");
-	char *p = strtok(NULL, ":");
-	p = strtok(p, ",");
-	do{
-	  addarguments(getplugin(name, plugins), p);
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case 'd':
-      if (arg != NULL){
-	char *p = strtok(arg, ",");
-	do{
-	  getplugin(p, plugins)->disable = true;
-	  p = strtok(NULL, ",");
-	} while (p);
-      }
-      break;
-    case 128:
-      plugindir = arg;
-      break;
-    case 129:
-      uid = (uid_t)strtol(arg, NULL, 10);
-      break;
-    case 130:
-      gid = (gid_t)strtol(arg, NULL, 10);
-      break;
-    case ARGP_KEY_ARG:
-      argp_usage (state);
-      break;
-    case ARGP_KEY_END:
-      break;
-    default:
-      return ARGP_ERR_UNKNOWN;
-    }
-    return 0;
-  }
-
-  plugin *plugin_list = NULL;
-  
-  struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = args_doc, .doc = doc };
-
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
-
-/*   for(plugin *p = plugin_list; p != NULL; p=p->next){ */
-/*     fprintf(stderr, "Plugin: %s has %d arguments\n", p->name ? p->name : "Global", p->argc); */
-/*     for(char **a = p->argv + 1; *a != NULL; a++){ */
-/*       fprintf(stderr, "\tArg: %s\n", *a); */
-/*     } */
-/*   } */
-  
-/*   return 0; */
-
-  ret = setuid(uid);
-  if (ret == -1){
-    perror("setuid");
-  }
-
-  setgid(gid);
-  if (ret == -1){
-    perror("setuid");
-  }
   
   dir = opendir(plugindir);
-  
+
   if(dir == NULL){
     fprintf(stderr, "Can not open directory\n");
     return EXIT_FAILURE;
@@ -249,38 +60,33 @@
 	or dirst->d_name[d_name_len - 1] == '~'){
       continue;
     }
-
-    char *filename = malloc(d_name_len + strlen(plugindir) + 2);
+    
+    char *filename = malloc(d_name_len + plugindir_len + 1);
     strcpy(filename, plugindir);
     strcat(filename, "/");
     strcat(filename, dirst->d_name);    
-
+    
     stat(filename, &st);
 
-    if (S_ISREG(st.st_mode)
-	and (access(filename, X_OK) == 0)
-	and not (getplugin(dirst->d_name, &plugin_list)->disable)){
+    if (S_ISREG(st.st_mode) and (access(filename, X_OK) == 0)){
       // Starting a new process to be watched
       process *new_process = malloc(sizeof(process));
-      int pipefd[2]; 
-      ret = pipe(pipefd);
-      if (ret == -1){
-	perror(argv[0]);
-	goto end;
-      }
+      int pipefd[2];
+      pipe(pipefd);
       new_process->pid = fork();
       if(new_process->pid == 0){
 	/* this is the child process */
 	closedir(dir);
 	close(pipefd[0]);	/* close unused read end of pipe */
 	dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
-
-	plugin *p = getplugin(dirst->d_name, &plugin_list);
-	plugin *g = getplugin(NULL, &plugin_list);
-	for(char **a = g->argv + 1; *a != NULL; a++){
-	  addarguments(p, *a);
+	/* create a new modified argument list */
+	char **new_argv = malloc(sizeof(char *) * argc + 1);
+	new_argv[0] = filename;
+	for(int i = 1; i < argc; i++){
+	  new_argv[i] = argv[i];
 	}
-	if(execv(filename, p->argv) < 0){
+	new_argv[argc] = NULL;
+	if(execv(filename, new_argv) < 0){
 	  perror(argv[0]);
 	  close(pipefd[1]);
 	  exit(EXIT_FAILURE);
@@ -325,7 +131,7 @@
 	       > process_itr->buffer_size){
 		process_itr->buffer = realloc(process_itr->buffer,
 					      process_itr->buffer_size
-					      + (size_t) BUFFER_SIZE);
+					      + BUFFER_SIZE);
 		if (process_itr->buffer == NULL){
 		  perror(argv[0]);
 		  goto end;
@@ -334,28 +140,15 @@
 	    }
 	    ret = read(process_itr->fd, process_itr->buffer
 		       + process_itr->buffer_length, BUFFER_SIZE);
-	    if(ret < 0){
-	      /* Read error from this process; ignore it */
-	      continue;
-	    }
-	    process_itr->buffer_length += (size_t) ret;
+	    process_itr->buffer_length+=ret;
 	    if(ret == 0){
 	      /* got EOF */
 	      /* wait for process exit */
 	      int status;
 	      waitpid(process_itr->pid, &status, 0);
 	      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
-		for(size_t written = 0;
-		    written < process_itr->buffer_length;){
-		  ret = write(STDOUT_FILENO,
-			      process_itr->buffer + written,
-			      process_itr->buffer_length - written);
-		  if(ret < 0){
-		    perror(argv[0]);
-		    goto end;
-		  }
-		  written += (size_t)ret;
-		}
+		write(STDOUT_FILENO, process_itr->buffer,
+		      process_itr->buffer_length);
 		goto end;
 	      } else {
 		FD_CLR(process_itr->fd, &rfds_orig);

=== added file 'plugins.d/Makefile'
--- plugins.d/Makefile	1970-01-01 00:00:00 +0000
+++ plugins.d/Makefile	2008-07-20 02:52:20 +0000
@@ -0,0 +1,18 @@
+CFLAGS=-Wall -g --std=gnu99
+LDFLAGS=-lgnutls -lavahi-core -lgpgme
+
+PROGS=mandosclient passprompt
+
+objects=mandosclient.o passprompt.o
+
+all: $(PROGS)
+
+mandosclient: mandosclient.o
+	$(LINK.o) -lgnutls -lavahi-core -lgpgme $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+passprompt: passprompt.o
+	$(LINK.o) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+.PHONY : clean
+clean :
+	-rm -f $(PROGS) $(objects) core

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-08-02 14:48:45 +0000
+++ plugins.d/mandosclient.c	2008-07-20 02:52:20 +0000
@@ -1,35 +1,34 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Mandos client - get and decrypt data from a Mandos server
+/* $Id$ */
+
+/* PLEASE NOTE *
+ * This file demonstrates how to use Avahi's core API, this is
+ * the embeddable mDNS stack for embedded applications.
  *
- * This program is partly derived from an example program for an Avahi
- * service browser, downloaded from
- * <http://avahi.org/browser/examples/core-browse-services.c>.  This
- * includes the following functions: "resolve_callback",
- * "browse_callback", and parts of "main".
- * 
- * Everything else is Copyright © 2007-2008 Teddy Hogeborn and Björn
- * Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
+ * End user applications should *not* use this API and should use
+ * the D-Bus or C APIs, please see
+ * client-browse-services.c and glib-integration.c
+ * 
+ * I repeat, you probably do *not* want to use this example.
  */
 
-#define _FORTIFY_SOURCE 2
+/***
+  This file is part of avahi.
+ 
+  avahi is free software; you can redistribute it and/or modify it
+  under the terms of the GNU Lesser General Public License as
+  published by the Free Software Foundation; either version 2.1 of the
+  License, or (at your option) any later version.
+ 
+  avahi is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
+  Public License for more details.
+ 
+  You should have received a copy of the GNU Lesser General Public
+  License along with avahi; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+  USA.
+***/
 
 #define _LARGEFILE_SOURCE
 #define _FILE_OFFSET_BITS 64
@@ -39,8 +38,6 @@
 #include <stdlib.h>
 #include <time.h>
 #include <net/if.h>		/* if_nametoindex */
-#include <sys/ioctl.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
-#include <net/if.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
 
 #include <avahi-core/core.h>
 #include <avahi-core/lookup.h>
@@ -50,11 +47,10 @@
 #include <avahi-common/error.h>
 
 //mandos client part
-#include <sys/types.h>		/* socket(), inet_pton() */
-#include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   struct in6_addr, inet_pton() */
-#include <gnutls/gnutls.h>	/* All GnuTLS stuff */
-#include <gnutls/openpgp.h>	/* GnuTLS with openpgp stuff */
+#include <sys/types.h>		/* socket(), setsockopt(), inet_pton() */
+#include <sys/socket.h>		/* socket(), setsockopt(), struct sockaddr_in6, struct in6_addr, inet_pton() */
+#include <gnutls/gnutls.h>	/* ALL GNUTLS STUFF */
+#include <gnutls/openpgp.h>	/* gnutls with openpgp stuff */
 
 #include <unistd.h>		/* close() */
 #include <netinet/in.h>
@@ -67,18 +63,15 @@
 #include <errno.h>		/* perror() */
 #include <gpgme.h>
 
-// getopt long
-#include <getopt.h>
 
+#ifndef CERT_ROOT
+#define CERT_ROOT "/conf/conf.d/cryptkeyreq/"
+#endif
+#define CERTFILE CERT_ROOT "openpgp-client.txt"
+#define KEYFILE CERT_ROOT "openpgp-client-key.txt"
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-const char *certdir = "/conf/conf.d/cryptkeyreq/";
-const char *certfile = "openpgp-client.txt";
-const char *certkey = "openpgp-client-key.txt";
-
-bool debug = false;
-
 typedef struct {
   gnutls_session_t session;
   gnutls_certificate_credentials_t cred;
@@ -86,28 +79,18 @@
 } encrypted_session;
 
 
-ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
-			    char **new_packet, const char *homedir){
+ssize_t gpg_packet_decrypt (char *packet, size_t packet_size, char **new_packet, char *homedir){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_ctx_t ctx;
   gpgme_error_t rc;
   ssize_t ret;
-  ssize_t new_packet_capacity = 0;
-  ssize_t new_packet_length = 0;
+  size_t new_packet_capacity = 0;
+  size_t new_packet_length = 0;
   gpgme_engine_info_t engine_info;
 
-  if (debug){
-    fprintf(stderr, "Trying to decrypt OpenPGP packet\n");
-  }
-  
   /* Init GPGME */
   gpgme_check_version(NULL);
-  rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return -1;
-  }
+  gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   
   /* Set GPGME home directory */
   rc = gpgme_get_engine_info (&engine_info);
@@ -153,62 +136,44 @@
     return -1;
   }
   
-  /* Decrypt data from the FILE pointer to the plaintext data
-     buffer */
+  /* Decrypt data from the FILE pointer to the plaintext data buffer */
   rc = gpgme_op_decrypt(ctx, dh_crypto, dh_plain);
   if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
-
-  if(debug){
-    fprintf(stderr, "Decryption of OpenPGP packet succeeded\n");
-  }
-
-  if (debug){
-    gpgme_decrypt_result_t result;
-    result = gpgme_op_decrypt_result(ctx);
-    if (result == NULL){
-      fprintf(stderr, "gpgme_op_decrypt_result failed\n");
-    } else {
-      fprintf(stderr, "Unsupported algorithm: %s\n",
-	      result->unsupported_algorithm);
-      fprintf(stderr, "Wrong key usage: %d\n",
-	      result->wrong_key_usage);
-      if(result->file_name != NULL){
-	fprintf(stderr, "File name: %s\n", result->file_name);
-      }
-      gpgme_recipient_t recipient;
-      recipient = result->recipients;
-      if(recipient){
-	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
-		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
-		  recipient->status == GPG_ERR_NO_SECKEY
-		  ? "No" : "Yes");
-	  recipient = recipient->next;
-	}
-      }
-    }
-  }
   
+/*   gpgme_decrypt_result_t result; */
+/*   result = gpgme_op_decrypt_result(ctx); */
+/*   fprintf(stderr, "Unsupported algorithm: %s\n", result->unsupported_algorithm); */
+/*   fprintf(stderr, "Wrong key usage: %d\n", result->wrong_key_usage); */
+/*   if(result->file_name != NULL){ */
+/*     fprintf(stderr, "File name: %s\n", result->file_name); */
+/*   } */
+/*   gpgme_recipient_t recipient; */
+/*   recipient = result->recipients; */
+/*   if(recipient){ */
+/*     while(recipient != NULL){ */
+/*       fprintf(stderr, "Public key algorithm: %s\n", */
+/* 	      gpgme_pubkey_algo_name(recipient->pubkey_algo)); */
+/*       fprintf(stderr, "Key ID: %s\n", recipient->keyid); */
+/*       fprintf(stderr, "Secret key available: %s\n", */
+/* 	      recipient->status == GPG_ERR_NO_SECKEY ? "No" : "Yes"); */
+/*       recipient = recipient->next; */
+/*     } */
+/*   } */
+
   /* Delete the GPGME FILE pointer cryptotext data buffer */
   gpgme_data_release(dh_crypto);
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
-  if (gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET) == -1){
-    perror("pgpme_data_seek");
-  }
-  
+  gpgme_data_seek(dh_plain, 0, SEEK_SET);
+
   *new_packet = 0;
   while(true){
     if (new_packet_length + BUFFER_SIZE > new_packet_capacity){
-      *new_packet = realloc(*new_packet,
-			    (unsigned int)new_packet_capacity
-			    + BUFFER_SIZE);
+      *new_packet = realloc(*new_packet, new_packet_capacity + BUFFER_SIZE);
       if (*new_packet == NULL){
 	perror("realloc");
 	return -1;
@@ -216,10 +181,10 @@
       new_packet_capacity += BUFFER_SIZE;
     }
     
-    ret = gpgme_data_read(dh_plain, *new_packet + new_packet_length,
-			  BUFFER_SIZE);
+    ret = gpgme_data_read(dh_plain, *new_packet + new_packet_length, BUFFER_SIZE);
     /* Print the data, if any */
     if (ret == 0){
+      /* If password is empty, then a incorrect error will be printed */
       break;
     }
     if(ret < 0){
@@ -229,15 +194,7 @@
     new_packet_length += ret;
   }
 
-  /* FIXME: check characters before printing to screen so to not print
-     terminal control characters */
-  /*   if(debug){ */
-  /*     fprintf(stderr, "decrypted password is: "); */
-  /*     fwrite(*new_packet, 1, new_packet_length, stderr); */
-  /*     fprintf(stderr, "\n"); */
-  /*   } */
-  
-  /* Delete the GPGME plaintext data buffer */
+   /* Delete the GPGME plaintext data buffer */
   gpgme_data_release(dh_plain);
   return new_packet_length;
 }
@@ -249,8 +206,7 @@
   return ret;
 }
 
-void debuggnutls(__attribute__((unused)) int level,
-		 const char* string){
+void debuggnutls(int level, const char* string){
   fprintf(stderr, "%s", string);
 }
 
@@ -258,79 +214,67 @@
   const char *err;
   int ret;
   
-  if(debug){
-    fprintf(stderr, "Initializing GnuTLS\n");
-  }
-
   if ((ret = gnutls_global_init ())
       != GNUTLS_E_SUCCESS) {
     fprintf (stderr, "global_init: %s\n", safer_gnutls_strerror(ret));
     return -1;
   }
 
-  if (debug){
-    gnutls_global_set_log_level(11);
-    gnutls_global_set_log_function(debuggnutls);
-  }
-  
+  /* Uncomment to enable full debuggin on the gnutls library */
+  /*   gnutls_global_set_log_level(11); */
+  /*   gnutls_global_set_log_function(debuggnutls); */
+
+
   /* openpgp credentials */
   if ((ret = gnutls_certificate_allocate_credentials (&es->cred))
       != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "memory error: %s\n",
-	     safer_gnutls_strerror(ret));
+    fprintf (stderr, "memory error: %s\n", safer_gnutls_strerror(ret));
     return -1;
   }
-  
-  if(debug){
-    fprintf(stderr, "Attempting to use OpenPGP certificate %s"
-	    " and keyfile %s as GnuTLS credentials\n", certfile,
-	    certkey);
-  }
-  
+
   ret = gnutls_certificate_set_openpgp_key_file
-    (es->cred, certfile, certkey, GNUTLS_OPENPGP_FMT_BASE64);
+    (es->cred, CERTFILE, KEYFILE, GNUTLS_OPENPGP_FMT_BASE64);
   if (ret != GNUTLS_E_SUCCESS) {
     fprintf
-      (stderr, "Error[%d] while reading the OpenPGP key pair ('%s',"
-       " '%s')\n",
-       ret, certfile, certkey);
+      (stderr, "Error[%d] while reading the OpenPGP key pair ('%s', '%s')\n",
+       ret, CERTFILE, KEYFILE);
     fprintf(stdout, "The Error is: %s\n",
 	    safer_gnutls_strerror(ret));
     return -1;
   }
-  
-  //GnuTLS server initialization
+
+  //Gnutls server initialization
   if ((ret = gnutls_dh_params_init (&es->dh_params))
       != GNUTLS_E_SUCCESS) {
     fprintf (stderr, "Error in dh parameter initialization: %s\n",
 	     safer_gnutls_strerror(ret));
     return -1;
   }
-  
+
   if ((ret = gnutls_dh_params_generate2 (es->dh_params, DH_BITS))
       != GNUTLS_E_SUCCESS) {
     fprintf (stderr, "Error in prime generation: %s\n",
 	     safer_gnutls_strerror(ret));
     return -1;
   }
-  
+
   gnutls_certificate_set_dh_params (es->cred, es->dh_params);
-  
-  // GnuTLS session creation
+
+  // Gnutls session creation
   if ((ret = gnutls_init (&es->session, GNUTLS_SERVER))
       != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
+    fprintf(stderr, "Error in gnutls session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
   }
-  
+
   if ((ret = gnutls_priority_set_direct (es->session, "NORMAL", &err))
       != GNUTLS_E_SUCCESS) {
     fprintf(stderr, "Syntax error at: %s\n", err);
-    fprintf(stderr, "GnuTLS error: %s\n",
+    fprintf(stderr, "Gnutls error: %s\n",
 	    safer_gnutls_strerror(ret));
     return -1;
   }
-  
+
   if ((ret = gnutls_credentials_set
        (es->session, GNUTLS_CRD_CERTIFICATE, es->cred))
       != GNUTLS_E_SUCCESS) {
@@ -338,57 +282,45 @@
 	    safer_gnutls_strerror(ret));
     return -1;
   }
-  
+
   /* ignore client certificate if any. */
-  gnutls_certificate_server_set_request (es->session,
-					 GNUTLS_CERT_IGNORE);
+  gnutls_certificate_server_set_request (es->session, GNUTLS_CERT_IGNORE);
   
   gnutls_dh_set_prime_bits (es->session, DH_BITS);
   
   return 0;
 }
 
-void empty_log(__attribute__((unused)) AvahiLogLevel level,
-	       __attribute__((unused)) const char *txt){}
+void empty_log(AvahiLogLevel level, const char *txt){}
 
-int start_mandos_communication(const char *ip, uint16_t port,
-			       unsigned int if_index){
+int start_mandos_communcation(char *ip, uint16_t port){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
+  struct in6_addr ip_addr;
   encrypted_session es;
   char *buffer = NULL;
   char *decrypted_buffer;
   size_t buffer_length = 0;
   size_t buffer_capacity = 0;
   ssize_t decrypted_buffer_size;
-  size_t written = 0;
   int retval = 0;
-  char interface[IF_NAMESIZE];
-  
-  if(debug){
-    fprintf(stderr, "Setting up a tcp connection to %s\n", ip);
-  }
+
   
   tcp_sd = socket(PF_INET6, SOCK_STREAM, 0);
   if(tcp_sd < 0) {
     perror("socket");
     return -1;
   }
-
-  if(debug){
-    if(if_indextoname(if_index, interface) == NULL){
-      if(debug){
-	perror("if_indextoname");
-      }
-      return -1;
-    }
-    
-    fprintf(stderr, "Binding to interface %s\n", interface);
+  
+  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
+  if(tcp_sd < 0) {
+    perror("setsockopt bindtodevice");
+    return -1;
   }
   
-  memset(&to,0,sizeof(to));	/* Spurious warning */
+  memset(&to,0,sizeof(to));
   to.sin6_family = AF_INET6;
-  ret = inet_pton(AF_INET6, ip, &to.sin6_addr);
+  ret = inet_pton(AF_INET6, ip, &ip_addr);
   if (ret < 0 ){
     perror("inet_pton");
     return -1;
@@ -397,13 +329,8 @@
     fprintf(stderr, "Bad address: %s\n", ip);
     return -1;
   }
-  to.sin6_port = htons(port);	/* Spurious warning */
-  
-  to.sin6_scope_id = (uint32_t)if_index;
-  
-  if(debug){
-    fprintf(stderr, "Connection to: %s\n", ip);
-  }
+  to.sin6_port = htons(port);
+  to.sin6_scope_id = if_nametoindex("eth0");
   
   ret = connect(tcp_sd, (struct sockaddr *) &to, sizeof(to));
   if (ret < 0){
@@ -416,32 +343,20 @@
     retval = -1;
     return -1;
   }
-  
-  gnutls_transport_set_ptr (es.session,
-			    (gnutls_transport_ptr_t) tcp_sd);
-  
-  if(debug){
-    fprintf(stderr, "Establishing TLS session with %s\n", ip);
-  }
-  
+    
+  
+  gnutls_transport_set_ptr (es.session, (gnutls_transport_ptr_t) tcp_sd);
+
   ret = gnutls_handshake (es.session);
   
   if (ret != GNUTLS_E_SUCCESS){
-    if(debug){
-      fprintf(stderr, "\n*** Handshake failed ***\n");
-      gnutls_perror (ret);
-    }
+    fprintf(stderr, "\n*** Handshake failed ***\n");
+    gnutls_perror (ret);
     retval = -1;
     goto exit;
   }
-  
-  //Retrieve OpenPGP packet that contains the wanted password
-  
-  if(debug){
-    fprintf(stderr, "Retrieving pgp encrypted password from %s\n",
-	    ip);
-  }
 
+  //retrive password
   while(true){
     if (buffer_length + BUFFER_SIZE > buffer_capacity){
       buffer = realloc(buffer, buffer_capacity + BUFFER_SIZE);
@@ -472,50 +387,28 @@
 	}
 	break;
       default:
-	fprintf(stderr, "Unknown error while reading data from"
-		" encrypted session with mandos server\n");
+	fprintf(stderr, "Unknown error while reading data from encrypted session with mandos server\n");
 	retval = -1;
 	gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
 	goto exit;
       }
     } else {
-      buffer_length += (size_t) ret;
+      buffer_length += ret;
     }
   }
-  
+
   if (buffer_length > 0){
-    decrypted_buffer_size = pgp_packet_decrypt(buffer,
-					       buffer_length,
-					       &decrypted_buffer,
-					       certdir);
-    if (decrypted_buffer_size >= 0){
-      while(written < (size_t)decrypted_buffer_size){
-	ret = (int)fwrite (decrypted_buffer + written, 1,
-			   (size_t)decrypted_buffer_size - written,
-			   stdout);
-	if(ret == 0 and ferror(stdout)){
-	  if(debug){
-	    fprintf(stderr, "Error writing encrypted data: %s\n",
-		    strerror(errno));
-	  }
-	  retval = -1;
-	  break;
-	}
-	written += (size_t)ret;
-      }
+    if ((decrypted_buffer_size = gpg_packet_decrypt(buffer, buffer_length, &decrypted_buffer, CERT_ROOT)) == 0){
+      retval = -1;
+    } else {
+      fwrite (decrypted_buffer, 1, decrypted_buffer_size, stdout);
       free(decrypted_buffer);
-    } else {
-      retval = -1;
     }
   }
 
+  free(buffer);
+
   //shutdown procedure
-
-  if(debug){
-    fprintf(stderr, "Closing TLS session\n");
-  }
-
-  free(buffer);
   gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
  exit:
   close(tcp_sd);
@@ -530,7 +423,7 @@
 
 static void resolve_callback(
     AvahiSServiceResolver *r,
-    AvahiIfIndex interface,
+    AVAHI_GCC_UNUSED AvahiIfIndex interface,
     AVAHI_GCC_UNUSED AvahiProtocol protocol,
     AvahiResolverEvent event,
     const char *name,
@@ -539,39 +432,31 @@
     const char *host_name,
     const AvahiAddress *address,
     uint16_t port,
-    AVAHI_GCC_UNUSED AvahiStringList *txt,
-    AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
+    AvahiStringList *txt,
+    AvahiLookupResultFlags flags,
     AVAHI_GCC_UNUSED void* userdata) {
     
-  assert(r);			/* Spurious warning */
-  
-  /* Called whenever a service has been resolved successfully or
-     timed out */
-  
-  switch (event) {
-  default:
-  case AVAHI_RESOLVER_FAILURE:
-    fprintf(stderr, "(Resolver) Failed to resolve service '%s' of"
-	    " type '%s' in domain '%s': %s\n", name, type, domain,
-	    avahi_strerror(avahi_server_errno(server)));
-    break;
-    
-  case AVAHI_RESOLVER_FOUND:
-    {
-      char ip[AVAHI_ADDRESS_STR_MAX];
-      avahi_address_snprint(ip, sizeof(ip), address);
-      if(debug){
-	fprintf(stderr, "Mandos server \"%s\" found on %s (%s) on"
-		" port %d\n", name, host_name, ip, port);
-      }
-      int ret = start_mandos_communication(ip, port,
-					   (unsigned int) interface);
-      if (ret == 0){
-	exit(EXIT_SUCCESS);
-      }
+    assert(r);
+
+    /* Called whenever a service has been resolved successfully or timed out */
+
+    switch (event) {
+        case AVAHI_RESOLVER_FAILURE:
+            fprintf(stderr, "(Resolver) Failed to resolve service '%s' of type '%s' in domain '%s': %s\n", name, type, domain, avahi_strerror(avahi_server_errno(server)));
+            break;
+
+        case AVAHI_RESOLVER_FOUND: {
+	  char ip[AVAHI_ADDRESS_STR_MAX];
+            avahi_address_snprint(ip, sizeof(ip), address);
+	    int ret = start_mandos_communcation(ip, port);
+	    if (ret == 0){
+	      exit(EXIT_SUCCESS);
+	    } else {
+	      exit(EXIT_FAILURE);
+	    }
+        }
     }
-  }
-  avahi_s_service_resolver_free(r);
+    avahi_s_service_resolver_free(r);
 }
 
 static void browse_callback(
@@ -586,156 +471,53 @@
     void* userdata) {
     
     AvahiServer *s = userdata;
-    assert(b);			/* Spurious warning */
-    
-    /* Called whenever a new services becomes available on the LAN or
-       is removed from the LAN */
-    
+    assert(b);
+
+    /* Called whenever a new services becomes available on the LAN or is removed from the LAN */
+
     switch (event) {
-    default:
-    case AVAHI_BROWSER_FAILURE:
-      
-      fprintf(stderr, "(Browser) %s\n",
-	      avahi_strerror(avahi_server_errno(server)));
-      avahi_simple_poll_quit(simple_poll);
-      return;
-      
-    case AVAHI_BROWSER_NEW:
-      /* We ignore the returned resolver object. In the callback
-	 function we free it. If the server is terminated before
-	 the callback function is called the server will free
-	 the resolver for us. */
-      
-      if (!(avahi_s_service_resolver_new(s, interface, protocol, name,
-					 type, domain,
-					 AVAHI_PROTO_INET6, 0,
-					 resolve_callback, s)))
-	fprintf(stderr, "Failed to resolve service '%s': %s\n", name,
-		avahi_strerror(avahi_server_errno(s)));
-      break;
-      
-    case AVAHI_BROWSER_REMOVE:
-      break;
-      
-    case AVAHI_BROWSER_ALL_FOR_NOW:
-    case AVAHI_BROWSER_CACHE_EXHAUSTED:
-      break;
+
+        case AVAHI_BROWSER_FAILURE:
+            
+            fprintf(stderr, "(Browser) %s\n", avahi_strerror(avahi_server_errno(server)));
+            avahi_simple_poll_quit(simple_poll);
+            return;
+
+        case AVAHI_BROWSER_NEW:
+            /* We ignore the returned resolver object. In the callback
+               function we free it. If the server is terminated before
+               the callback function is called the server will free
+               the resolver for us. */
+            
+            if (!(avahi_s_service_resolver_new(s, interface, protocol, name, type, domain, AVAHI_PROTO_INET6, 0, resolve_callback, s)))
+                fprintf(stderr, "Failed to resolve service '%s': %s\n", name, avahi_strerror(avahi_server_errno(s)));
+            
+            break;
+
+        case AVAHI_BROWSER_REMOVE:
+            break;
+
+        case AVAHI_BROWSER_ALL_FOR_NOW:
+        case AVAHI_BROWSER_CACHE_EXHAUSTED:
+            break;
     }
 }
 
-/* combinds file name and path and returns the malloced new string. som sane checks could/should be added */
-const char *combinepath(const char *first, const char *second){
-  char *tmp;
-  tmp = malloc(strlen(first) + strlen(second) + 2);
-  if (tmp == NULL){
-    perror("malloc");
-    return NULL;
-  }
-  strcpy(tmp, first);
-  if (first[0] != '\0' and first[strlen(first) - 1] != '/'){
-    strcat(tmp, "/");
-  }
-  strcat(tmp, second);
-  return tmp;
-}
-
-
 int main(AVAHI_GCC_UNUSED int argc, AVAHI_GCC_UNUSED char*argv[]) {
     AvahiServerConfig config;
     AvahiSServiceBrowser *sb = NULL;
     int error;
-    int ret;
-    int returncode = EXIT_SUCCESS;
-    const char *interface = "eth0";
-    struct ifreq network;
-    int sd;
-    
-    while (true){
-      static struct option long_options[] = {
-	{"debug", no_argument, (int *)&debug, 1},
-	{"interface", required_argument, 0, 'i'},
-	{"certdir", required_argument, 0, 'd'},
-	{"certkey", required_argument, 0, 'c'},
-	{"certfile", required_argument, 0, 'k'},
-	{0, 0, 0, 0} };
-      
-      int option_index = 0;
-      ret = getopt_long (argc, argv, "i:", long_options,
-			 &option_index);
-      
-      if (ret == -1){
-	break;
-      }
-      
-      switch(ret){
-      case 0:
-	break;
-      case 'i':
-	interface = optarg;
-	break;
-      case 'd':
-	certdir = optarg;
-	break;
-      case 'c':
-	certfile = optarg;
-	break;
-      case 'k':
-	certkey = optarg;
-	break;
-      default:
-	exit(EXIT_FAILURE);
-      }
-    }
-
-    certfile = combinepath(certdir, certfile);
-    if (certfile == NULL){
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    
-    certkey = combinepath(certdir, certkey);
-    if (certkey == NULL){
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0) {
-      perror("socket");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    strcpy(network.ifr_name, interface);    
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      
-      perror("ioctl SIOCGIFFLAGS");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    if((network.ifr_flags & IFF_UP) == 0){
-      network.ifr_flags |= IFF_UP;
-      ret = ioctl(sd, SIOCSIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCSIFFLAGS");
-	returncode = EXIT_FAILURE;
-	goto exit;
-      }
-    }
-    close(sd);
-    
-    if (not debug){
-      avahi_set_log_function(empty_log);
-    }
+    int ret = 1;
+
+    avahi_set_log_function(empty_log);
     
     /* Initialize the psuedo-RNG */
-    srand((unsigned int) time(NULL));
+    srand(time(NULL));
 
     /* Allocate main loop object */
     if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	returncode = EXIT_FAILURE;	
-        goto exit;
+        goto fail;
     }
 
     /* Do not publish any local records */
@@ -745,48 +527,35 @@
     config.publish_workstation = 0;
     config.publish_domain = 0;
 
+/*     /\* Set a unicast DNS server for wide area DNS-SD *\/ */
+/*     avahi_address_parse("193.11.177.11", AVAHI_PROTO_UNSPEC, &config.wide_area_servers[0]); */
+/*     config.n_wide_area_servers = 1; */
+/*     config.enable_wide_area = 1; */
+    
     /* Allocate a new server */
-    server = avahi_server_new(avahi_simple_poll_get(simple_poll),
-			      &config, NULL, NULL, &error);
+    server = avahi_server_new(avahi_simple_poll_get(simple_poll), &config, NULL, NULL, &error);
 
     /* Free the configuration data */
     avahi_server_config_free(&config);
 
-    /* Check if creating the server object succeeded */
+    /* Check wether creating the server object succeeded */
     if (!server) {
-        fprintf(stderr, "Failed to create server: %s\n",
-		avahi_strerror(error));
-	returncode = EXIT_FAILURE;
-        goto exit;
+        fprintf(stderr, "Failed to create server: %s\n", avahi_strerror(error));
+        goto fail;
     }
     
     /* Create the service browser */
-    sb = avahi_s_service_browser_new(server,
-				     (AvahiIfIndex)
-				     if_nametoindex(interface),
-				     AVAHI_PROTO_INET6,
-				     "_mandos._tcp", NULL, 0,
-				     browse_callback, server);
-    if (!sb) {
-        fprintf(stderr, "Failed to create service browser: %s\n",
-		avahi_strerror(avahi_server_errno(server)));
-	returncode = EXIT_FAILURE;
-        goto exit;
+    if (!(sb = avahi_s_service_browser_new(server, if_nametoindex("eth0"), AVAHI_PROTO_INET6, "_mandos._tcp", NULL, 0, browse_callback, server))) {
+        fprintf(stderr, "Failed to create service browser: %s\n", avahi_strerror(avahi_server_errno(server)));
+        goto fail;
     }
     
     /* Run the main loop */
-
-    if (debug){
-      fprintf(stderr, "Starting avahi loop search\n");
-    }
-    
     avahi_simple_poll_loop(simple_poll);
     
- exit:
-
-    if (debug){
-      fprintf(stderr, "%s exiting\n", argv[0]);
-    }
+    ret = 0;
+    
+fail:
     
     /* Cleanup things */
     if (sb)
@@ -797,8 +566,6 @@
 
     if (simple_poll)
         avahi_simple_poll_free(simple_poll);
-    free(certfile);
-    free(certkey);
-    
-    return returncode;
+
+    return ret;
 }

=== modified file 'plugins.d/passprompt.c'
--- plugins.d/passprompt.c	2008-07-21 15:34:44 +0000
+++ plugins.d/passprompt.c	2008-07-20 02:52:20 +0000
@@ -1,30 +1,5 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from the terminal and print it
- *
- * Copyright © 2007-2008 Teddy Hogeborn and Björn Påhlsson.
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* getline() */
 #define _FORTIFY_SOURCE 2
-
 #include <termios.h> 		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
@@ -36,66 +11,29 @@
 				   SIGQUIT, SIGHUP, SIGTERM */
 #include <stddef.h>		/* NULL, size_t */
 #include <sys/types.h>		/* ssize_t */
-#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getopt_long */
+#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), perror(), fputc(),
-				   stdout, getopt_long */
+				   stdout */
 #include <errno.h>		/* errno, EINVAL */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex, strncmp, strcmp */
-#include <getopt.h>		/* getopt_long */
 
 volatile bool quit_now = false;
-bool debug = false;
 
-void termination_handler(__attribute__((unused))int signum){
+void termination_handler(int signum){
   quit_now = true;
 }
 
 int main(int argc, char **argv){
-  ssize_t ret;
+  ssize_t ret = -1;
   size_t n;
   struct termios t_new, t_old;
   char *buffer = NULL;
-  char *prefix = NULL;
   int status = EXIT_SUCCESS;
   struct sigaction old_action,
     new_action = { .sa_handler = termination_handler,
 		   .sa_flags = 0 };
-
-  while (true){
-    static struct option long_options[] = {
-      {"debug", no_argument, (int *)&debug, 1},
-      {"prefix", required_argument, 0, 'p'},
-      {0, 0, 0, 0} };
-
-    int option_index = 0;
-    ret = getopt_long (argc, argv, "p:", long_options, &option_index);
-
-    if (ret == -1){
-      break;
-    }
-      
-    switch(ret){
-    case 0:
-      break;
-    case 'p':
-      prefix = optarg;
-      break;
-    default:
-      fprintf(stderr, "bad arguments\n");
-      exit(EXIT_FAILURE);
-    }
-  }
-      
-  if (debug){
-    fprintf(stderr, "Starting %s\n", argv[0]);
-  }
-  if (debug){
-    fprintf(stderr, "Storing current terminal attributes\n");
-  }
   
   if (tcgetattr(STDIN_FILENO, &t_old) != 0){
     return EXIT_FAILURE;
@@ -118,11 +56,6 @@
   sigaction(SIGTERM, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGTERM, &new_action, NULL);
-
-  
-  if (debug){
-    fprintf(stderr, "Removing echo flag from terminal attributes\n");
-  }
   
   t_new = t_old;
   t_new.c_lflag &= ~ECHO;
@@ -130,21 +63,13 @@
     perror("tcsetattr-echo");
     return EXIT_FAILURE;
   }
-
-  if (debug){
-    fprintf(stderr, "Waiting for input from stdin \n");
-  }
+  
   while(true){
     if (quit_now){
       status = EXIT_FAILURE;
       break;
     }
-
-    if(prefix){
-      fprintf(stderr, "%s Password: ", prefix);
-    } else {
-      fprintf(stderr, "Password: ");
-    }      
+    fprintf(stderr, "Password: ");
     ret = getline(&buffer, &n, stdin);
     if (ret > 0){
       fprintf(stdout, "%s", buffer);
@@ -162,16 +87,9 @@
     fputc('\n', stderr);
   }
 
-  if (debug){
-    fprintf(stderr, "Restoring terminal attributes\n");
-  }
   if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
     perror("tcsetattr+echo");
   }
-
-  if (debug){
-    fprintf(stderr, "%s is exiting\n", argv[0]);
-  }
   
   return status;
 }

=== modified file 'server.py'
--- server.py	2008-07-22 06:23:29 +0000
+++ server.py	2008-07-20 02:52:20 +0000
@@ -1,34 +1,4 @@
 #!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos server - give out binary blobs to connecting clients.
-# 
-# This program is partly derived from an example program for an Avahi
-# service publisher, downloaded from
-# <http://avahi.org/wiki/PythonPublishExample>.  This includes the
-# following functions: "add_service", "remove_service",
-# "server_state_changed", "entry_group_state_changed", and some lines
-# in "main".
-# 
-# Everything else is Copyright © 2007-2008 Teddy Hogeborn and Björn
-# Påhlsson.
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
-# <https://www.fukt.bsnet.se/~teddy/>.
-# 
 
 from __future__ import division
 
@@ -51,10 +21,6 @@
 import signal
 from sets import Set
 import subprocess
-import atexit
-import stat
-import logging
-import logging.handlers
 
 import dbus
 import gobject
@@ -62,32 +28,20 @@
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 
-# Brief description of the operation of this program:
-# 
-# This server announces itself as a Zeroconf service.  Connecting
-# clients use the TLS protocol, with the unusual quirk that this
-# server program acts as a TLS "client" while the connecting clients
-# acts as a TLS "server".  The clients (acting as a TLS "server") must
-# supply an OpenPGP certificate, and the fingerprint of this
-# certificate is used by this server to look up (in a list read from a
-# file at start time) which binary blob to give the client.  No other
-# authentication or authorization is done by this server.
+import logging
+import logging.handlers
 
+# logghandler.setFormatter(logging.Formatter('%(levelname)s %(message)s')
 
 logger = logging.Logger('mandos')
-syslogger = logging.handlers.SysLogHandler\
-            (facility = logging.handlers.SysLogHandler.LOG_DAEMON)
-syslogger.setFormatter(logging.Formatter\
-                        ('%(levelname)s: %(message)s'))
-logger.addHandler(syslogger)
-del syslogger
+logger.addHandler(logging.handlers.SysLogHandler(facility = logging.handlers.SysLogHandler.LOG_DAEMON))
 
 # This variable is used to optionally bind to a specified interface.
 # It is a global variable to fit in with the other variables from the
-# Avahi example code.
+# Avahi server example code.
 serviceInterface = avahi.IF_UNSPEC
-# From the Avahi example code:
-serviceName = None
+# From the Avahi server example code:
+serviceName = "Mandos"
 serviceType = "_mandos._tcp" # http://www.dns-sd.org/ServiceTypes.html
 servicePort = None                      # Not known at startup
 serviceTXT = []                         # TXT record for the service
@@ -152,18 +106,14 @@
     interval = property(lambda self: self._interval,
                         _set_interval)
     del _set_interval
-    def __init__(self, name=None, stop_hook=None, fingerprint=None,
-                 secret=None, secfile=None, fqdn=None, timeout=None,
-                 interval=-1, checker=None):
-        """Note: the 'checker' argument sets the 'checker_command'
-        attribute and not the 'checker' attribute.."""
+    def __init__(self, name=None, options=None, stop_hook=None,
+                 fingerprint=None, secret=None, secfile=None, fqdn=None,
+                 timeout=None, interval=-1, checker=None):
         self.name = name
-        logger.debug(u"Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint
         # for later comparison purposes with return value of
         # the fingerprint() function
         self.fingerprint = fingerprint.upper().replace(u" ", u"")
-        logger.debug(u"  Fingerprint: %s", self.fingerprint)
         if secret:
             self.secret = secret.decode(u"base64")
         elif secfile:
@@ -176,8 +126,14 @@
         self.fqdn = fqdn                # string
         self.created = datetime.datetime.now()
         self.last_seen = None
-        self.timeout = string_to_delta(timeout)
-        self.interval = string_to_delta(interval)
+        if timeout is None:
+            timeout = options.timeout
+        self.timeout = timeout
+        if interval == -1:
+            interval = options.interval
+        else:
+            interval = string_to_delta(interval)
+        self.interval = interval
         self.stop_hook = stop_hook
         self.checker = None
         self.checker_initiator_tag = None
@@ -185,7 +141,7 @@
         self.checker_callback_tag = None
         self.check_command = checker
     def start(self):
-        """Start this client's checker and timeout hooks"""
+        """Start this clients checker and timeout hooks"""
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
         self.checker_initiator_tag = gobject.timeout_add\
@@ -201,18 +157,12 @@
         """Stop this client.
         The possibility that this client might be restarted is left
         open, but not currently used."""
-        # If this client doesn't have a secret, it is already stopped.
-        if self.secret:
-            logger.debug(u"Stopping client %s", self.name)
-            self.secret = None
-        else:
-            return False
-        if hasattr(self, "stop_initiator_tag") \
-               and self.stop_initiator_tag:
+        logger.debug(u"Stopping client %s", self.name)
+        self.secret = None
+        if self.stop_initiator_tag:
             gobject.source_remove(self.stop_initiator_tag)
             self.stop_initiator_tag = None
-        if hasattr(self, "checker_initiator_tag") \
-               and self.checker_initiator_tag:
+        if self.checker_initiator_tag:
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
@@ -221,13 +171,19 @@
         # Do not run this again if called by a gobject.timeout_add
         return False
     def __del__(self):
-        self.stop_hook = None
-        self.stop()
+        # Some code duplication here and in stop()
+        if hasattr(self, "stop_initiator_tag") \
+               and self.stop_initiator_tag:
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = None
+        if hasattr(self, "checker_initiator_tag") \
+               and self.checker_initiator_tag:
+            gobject.source_remove(self.checker_initiator_tag)
+            self.checker_initiator_tag = None
+        self.stop_checker()
     def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
         now = datetime.datetime.now()
-        self.checker_callback_tag = None
-        self.checker = None
         if os.WIFEXITED(condition) \
                and (os.WEXITSTATUS(condition) == 0):
             logger.debug(u"Checker for %(name)s succeeded",
@@ -237,25 +193,21 @@
             self.stop_initiator_tag = gobject.timeout_add\
                                       (self._timeout_milliseconds,
                                        self.stop)
-        elif not os.WIFEXITED(condition):
+        if not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
         else:
             logger.debug(u"Checker for %(name)s failed",
                          vars(self))
+            self.checker = None
+        self.checker_callback_tag = None
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
         nothing."""
-        # The reason for not killing a running checker is that if we
-        # did that, then if a checker (for some reason) started
-        # running slowly and taking more than 'interval' time, the
-        # client would inevitably timeout, since no checker would get
-        # a chance to run to completion.  If we instead leave running
-        # checkers alone, the checker would have to take more time
-        # than 'timeout' for the client to be declared invalid, which
-        # is as it should be.
         if self.checker is None:
+            logger.debug(u"Starting checker for %s",
+                         self.name)
             try:
                 command = self.check_command % self.fqdn
             except TypeError:
@@ -265,19 +217,19 @@
                 try:
                     command = self.check_command % escaped_attrs
                 except TypeError, error:
-                    logger.critical(u'Could not format string "%s":'
-                                    u' %s', self.check_command, error)
+                    logger.critical(u'Could not format string "%s": %s',
+                                    self.check_command, error)
                     return True # Try again later
             try:
-                logger.debug(u"Starting checker %r for %s",
-                             command, self.name)
                 self.checker = subprocess.\
                                Popen(command,
+                                     stdout=subprocess.PIPE,
                                      close_fds=True, shell=True,
                                      cwd="/")
-                self.checker_callback_tag = gobject.child_watch_add\
-                                            (self.checker.pid,
-                                             self.checker_callback)
+                self.checker_callback_tag = gobject.\
+                                            child_watch_add(self.checker.pid,
+                                                            self.\
+                                                            checker_callback)
             except subprocess.OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
@@ -285,20 +237,13 @@
         return True
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
-        if self.checker_callback_tag:
-            gobject.source_remove(self.checker_callback_tag)
-            self.checker_callback_tag = None
         if not hasattr(self, "checker") or self.checker is None:
             return
-        logger.debug("Stopping checker for %(name)s", vars(self))
-        try:
-            os.kill(self.checker.pid, signal.SIGTERM)
-            #os.sleep(0.5)
-            #if self.checker.poll() is None:
-            #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
-            if error.errno != errno.ESRCH:
-                raise
+        gobject.source_remove(self.checker_callback_tag)
+        self.checker_callback_tag = None
+        os.kill(self.checker.pid, signal.SIGTERM)
+        if self.checker.poll() is None:
+            os.kill(self.checker.pid, signal.SIGKILL)
         self.checker = None
     def still_valid(self, now=None):
         """Has the timeout not yet passed for this client?"""
@@ -311,7 +256,6 @@
 
 
 def peer_certificate(session):
-    "Return the peer's OpenPGP certificate as a bytestring"
     # If not an OpenPGP certificate...
     if gnutls.library.functions.gnutls_certificate_type_get\
             (session._c_object) \
@@ -328,7 +272,6 @@
 
 
 def fingerprint(openpgp):
-    "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
     gnutls.library.functions.gnutls_openpgp_crt_init\
@@ -373,9 +316,8 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        priority = "NORMAL"
-        if self.server.options.priority:
-            priority = self.server.options.priority
+        priority = "SECURE256"
+        
         gnutls.library.functions.gnutls_priority_set_direct\
             (session._c_object, priority, None);
         
@@ -394,7 +336,7 @@
             return
         logger.debug(u"Fingerprint: %s", fpr)
         client = None
-        for c in self.server.clients:
+        for c in clients:
             if c.fingerprint == fpr:
                 client = c
                 break
@@ -501,7 +443,7 @@
 
 
 def add_service():
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     global group, serviceName, serviceType, servicePort, serviceTXT, \
            domain, host
     if group is None:
@@ -526,7 +468,7 @@
 
 
 def remove_service():
-    """From the Avahi example code"""
+    """From the Avahi server example code"""
     global group
     
     if not group is None:
@@ -534,7 +476,7 @@
 
 
 def server_state_changed(state):
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     if state == avahi.SERVER_COLLISION:
         logger.warning(u"Server name collision")
         remove_service()
@@ -543,7 +485,7 @@
 
 
 def entry_group_state_changed(state, error):
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     global serviceName, server, rename_count
     
     logger.debug(u"state change: %i", state)
@@ -561,13 +503,15 @@
             add_service()
             
         else:
-            logger.error(u"No suitable service name found after %i"
-                         u" retries, exiting.", n_rename)
-            killme(1)
+            logger.error(u"No suitable service name found "
+                         u"after %i retries, exiting.",
+                         n_rename)
+            main_loop.quit()
     elif state == avahi.ENTRY_GROUP_FAILURE:
         logger.error(u"Error in group state changed %s",
                      unicode(error))
-        killme(1)
+        main_loop.quit()
+        return
 
 
 def if_nametoindex(interface):
@@ -589,60 +533,35 @@
         return interface_index
 
 
-def daemon(nochdir, noclose):
-    """See daemon(3).  Standard BSD Unix function.
-    This should really exist as os.daemon, but it doesn't (yet)."""
-    if os.fork():
-        sys.exit()
-    os.setsid()
-    if not nochdir:
-        os.chdir("/")
-    if not noclose:
-        # Close all standard open file descriptors
-        null = os.open("/dev/null", os.O_NOCTTY | os.O_RDWR)
-        if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV,
-                          "/dev/null not a character device")
-        os.dup2(null, sys.stdin.fileno())
-        os.dup2(null, sys.stdout.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        if null > 2:
-            os.close(null)
-
-
-def killme(status = 0):
-    logger.debug("Stopping server with exit status %d", status)
-    exitstatus = status
-    if main_loop_started:
-        main_loop.quit()
-    else:
-        sys.exit(status)
-
-
-def main():
-    global exitstatus
-    exitstatus = 0
-    global main_loop_started
-    main_loop_started = False
-    
+if __name__ == '__main__':
     parser = OptionParser()
     parser.add_option("-i", "--interface", type="string",
                       default=None, metavar="IF",
                       help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string", default=None,
-                      help="Address to listen for requests on")
+    parser.add_option("--cert", type="string", default="cert.pem",
+                      metavar="FILE",
+                      help="Public key certificate PEM file to use")
+    parser.add_option("--key", type="string", default="key.pem",
+                      metavar="FILE",
+                      help="Private key PEM file to use")
+    parser.add_option("--ca", type="string", default="ca.pem",
+                      metavar="FILE",
+                      help="Certificate Authority certificate PEM file to use")
+    parser.add_option("--crl", type="string", default="crl.pem",
+                      metavar="FILE",
+                      help="Certificate Revokation List PEM file to use")
     parser.add_option("-p", "--port", type="int", default=None,
                       help="Port number to receive requests on")
+    parser.add_option("--timeout", type="string", # Parsed later
+                      default="1h",
+                      help="Amount of downtime allowed for clients")
+    parser.add_option("--interval", type="string", # Parsed later
+                      default="5m",
+                      help="How often to check that a client is up")
     parser.add_option("--check", action="store_true", default=False,
                       help="Run self-test")
     parser.add_option("--debug", action="store_true", default=False,
                       help="Debug mode")
-    parser.add_option("--priority", type="string",
-                      default="SECURE256",
-                      help="GnuTLS priority string"
-                      " (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      default="Mandos", help="Zeroconf service name")
     (options, args) = parser.parse_args()
     
     if options.check:
@@ -650,22 +569,23 @@
         doctest.testmod()
         sys.exit()
     
+    # Parse the time arguments
+    try:
+        options.timeout = string_to_delta(options.timeout)
+    except ValueError:
+        parser.error("option --timeout: Unparseable time")
+    try:
+        options.interval = string_to_delta(options.interval)
+    except ValueError:
+        parser.error("option --interval: Unparseable time")
+    
     # Parse config file
-    defaults = { "timeout": "1h",
-                 "interval": "5m",
-                 "checker": "fping -q -- %%(fqdn)s",
-                 }
+    defaults = { "checker": "sleep 1; fping -q -- %%(fqdn)s" }
     client_config = ConfigParser.SafeConfigParser(defaults)
-    #client_config.readfp(open("global.conf"), "global.conf")
+    #client_config.readfp(open("secrets.conf"), "secrets.conf")
     client_config.read("mandos-clients.conf")
     
-    global serviceName
-    serviceName = options.servicename;
-    
-    global main_loop
-    global bus
-    global server
-    # From the Avahi example code
+    # From the Avahi server example code
     DBusGMainLoop(set_as_default=True )
     main_loop = gobject.MainLoop()
     bus = dbus.SystemBus()
@@ -676,74 +596,35 @@
     
     debug = options.debug
     
-    if debug:
-        console = logging.StreamHandler()
-        # console.setLevel(logging.DEBUG)
-        console.setFormatter(logging.Formatter\
-                             ('%(levelname)s: %(message)s'))
-        logger.addHandler(console)
-        del console
-    
     clients = Set()
     def remove_from_clients(client):
         clients.remove(client)
         if not clients:
             logger.debug(u"No clients left, exiting")
-            killme()
+            main_loop.quit()
     
-    clients.update(Set(Client(name=section,
+    clients.update(Set(Client(name=section, options=options,
                               stop_hook = remove_from_clients,
                               **(dict(client_config\
                                       .items(section))))
                        for section in client_config.sections()))
-    
-    if not debug:
-        daemon(False, False)
-    
-    def cleanup():
-        "Cleanup function; run on exit"
-        global group
-        # From the Avahi example code
-        if not group is None:
-            group.Free()
-            group = None
-        # End of Avahi example code
-        
-        while clients:
-            client = clients.pop()
-            client.stop_hook = None
-            client.stop()
-    
-    atexit.register(cleanup)
-    
-    if not debug:
-        signal.signal(signal.SIGINT, signal.SIG_IGN)
-    signal.signal(signal.SIGHUP, lambda signum, frame: killme())
-    signal.signal(signal.SIGTERM, lambda signum, frame: killme())
-    
     for client in clients:
         client.start()
     
-    tcp_server = IPv6_TCPServer((options.address, options.port),
+    tcp_server = IPv6_TCPServer((None, options.port),
                                 tcp_handler,
                                 options=options,
                                 clients=clients)
     # Find out what random port we got
-    global servicePort
     servicePort = tcp_server.socket.getsockname()[1]
     logger.debug(u"Now listening on port %d", servicePort)
     
     if options.interface is not None:
-        global serviceInterface
         serviceInterface = if_nametoindex(options.interface)
     
-    # From the Avahi example code
+    # From the Avahi server example code
     server.connect_to_signal("StateChanged", server_state_changed)
-    try:
-        server_state_changed(server.GetState())
-    except dbus.exceptions.DBusException, error:
-        logger.critical(u"DBusException: %s", error)
-        killme(1)
+    server_state_changed(server.GetState())
     # End of Avahi example code
     
     gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
@@ -751,14 +632,17 @@
                          tcp_server.handle_request(*args[2:],
                                                    **kwargs) or True)
     try:
-        logger.debug("Starting main loop")
-        main_loop_started = True
         main_loop.run()
     except KeyboardInterrupt:
-        if debug:
-            print
+        print
     
-    sys.exit(exitstatus)
+    # Cleanup here
 
-if __name__ == '__main__':
-    main()
+    # From the Avahi server example code
+    if not group is None:
+        group.Free()
+    # End of Avahi example code
+    
+    for client in clients:
+        client.stop_hook = None
+        client.stop()

